Download Button - Patch #1860

Download button Wiki/Textile macro
26 Sep 2011 10:58 - Andriy Lesyuk

Status: Closed Start date: 26 Sep 2011
Priority: Normal Due date: 28 Jan 2012
Assignee: Andriy Lesyuk % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 0.0.3

Redmine version: External issue: ChiliProject#816
Description

Many times | wanted to put Download button in Wiki pages, news etc.

So it would be nice to have a macro like {DOWNLOAD]}...

History

#1 - 05 Jan 2012 19:28 - Andreas Schuh
- File compatibility_with_chili_project_and_addition_of wiki_macro_or_liquid_tag for_chili_project 3_0.patch added

Wow, | actually didn’t notice this issue before... | just implemented this and wanted to share the patch with you.
The implementation for Redmine was actually quickly done, but the new Liquid layer in ChiliProject 3.0 gave me some troubles. However, here it is.

Use in Redmine/ChiliProject < 3.0 as follows: {{download_button}}
Use in ChiliProject >= 3.0 as follows: {% download_button %}

Additionally, each of these macros/tags can have additional attributes to slightly change the style and/or the attributes of the DownloadButton.

For example,

Redmine/ChiliProject 2.x

{{download_button (package=nifticlib, label=Get the NIfTI library for C!, include_version=false, width=200px, f

ont_size=20px) }}
{{download_button (float=left, margin_right=10px) }}

ChiliProject 3.x:

{% download_button package=nifticlib, label=Get the NIfTI library for C!, include_version=false, width=200px,
font_size=20px %}

{% download_button float=left, margin_right=10px %}

(optionally, the argument list can in this case be enclosed in either braces, double quotes, or single quotes)

You may consider renaming this macro/tag to {{download}} if you prefer. | was just thinking download_button clarifies that the macro/tag will only
place a button there, but not perform a download action... on the other side, the name of the plugin is download. The decision is up to you.

BTW This macro/tag works also great with your sidebar content plugin. This way it is even better configurable for which views to render the download
button in the sidebar. Further it can be accompanied by additional text/graphics...

09 Apr 2024 1/2




#2 - 05 Jan 2012 20:42 - Andreas Schuh
- File 02-compatibility_with_chili_project_and_addition_of _wiki_macro_or _liquid_tag_for chili_project 3_0.patch added

Here is a clean version of the patch with all unnecessary changes reverted which | made while | was trying to get the Liquid tag for ChiliProject 3.0
working... further, | reverted the bump of the version number here as well.

#3 - 05 Jan 2012 22:32 - Andreas Schuh
- File 03-compatibility _with_chili_project_and_addition_of wiki_macro_or_liquid_tag for_chili_project 3 0.patch added

Of course | yet found some bugs in the parsing of the macro arguments (shouldn’t have just copied the function from Redmine). Played more with it
now and am satisfied so far. | renamed the macro to !{{download}}, respectively, {% download %} now, by the way.

#4 - 06 Jan 2012 14:18 - Andriy Lesyuk

Wow! Thank you very much! Will include your changes in the next version!

#5 - 06 Jan 2012 14:19 - Andriy Lesyuk

- Target version set to 0.0.3

#6 - 09 Jan 2012 05:34 - Andreas Schuh
- File 04-compatibility _with_chili_project_and_addition_of wiki_macro_or_liquid_tag for chili_project 3 0.patch added

| just noticed a minor mistake in the patch. | forgot to remove the obsolete code from DownloadMacroHelper#extract_download_options() which has
been moved to DownloadMacroHelper#to_container_style() and DownloadMacroHelper#to_button_style(), respectively.

So here’s the once more modified patch...

#7 - 27 Jan 2012 12:40 - Andriy Lesyuk
- Tracker changed from Feature to Patch
- % Done changed from 0 to 80

- External issue set to ChiliProject#816

#8 - 28 Jan 2012 15:06 - Andriy Lesyuk
- Due date set to 28 Jan 2012

- Status changed from Open to Closed

- % Done changed from 80 to 100

Files

compatibility_with_chili_project_and_addition_of_wiki_macro_or_liquid12a8 K& _chili_d36jdan 200 Datch Andreas Schuh
02-compatibility_with_chili_project_and_addition_of wiki_macro_or_liqldd7 848 for_chil5Sptaie20 12 0.patch Andreas Schuh
03-compatibility_with_chili_project_and_addition_of wiki_macro_or_liglid4 848 for_chilSptaie20 12 0.patch Andreas Schuh
04-compatibility_with_chili_project_and_addition_of wiki_macro_or_liqldd2 448 for_chil9ptaie20 12 0.patch Andreas Schuh
